﻿/*USAGE:
***THIS CLASS REQUIRES THE TWEENLITE LIBRARY
this class creates a simple bounce effect on rollover. 
BounceButton has no timeline animation.
graphic_mc = a MovieClip that conains all of the button's graphic elements.
A hit area MovieClip is placed on top of Graphic_mc to prevent rollover "flickering"
*/

package com.wastedpotential  {
	import flash.events.MouseEvent;
	import flash.display.MovieClip;
	import fl.transitions.easing.*; 
	import gs.TweenLite;
	    
    public class BounceButtonTweenLite extends MovieClip{

		public var isActive:Boolean = true;
		private var scaleTween:TweenLite;
		
		private var DURATION:Number = 1; //Number of seconds that the bounce lasts
		private var FINAL_SCALE:Number = 1.15; //the final scale of the bounce tween.
		
		
		//- CONSTRUCTOR 
		public function BounceButtonTweenLite() {
			//trace("BounceButtonTweenLite :: CONSTRUCTOR");
			this.buttonMode = true;
			//this.mouseChildren = false;
			this.addEventListener(MouseEvent.ROLL_OVER, onMouseOver);
			this.addEventListener(MouseEvent.ROLL_OUT, onMouseOut);
		} 	   
	   
		//- handles the rollover response for a button 
		private function onMouseOver(evt:MouseEvent):void{
			//trace("BounceButtonTweenLite :: onMouseOver");
			if(isActive) {
				highlightMe();
			}
		}
	   
		//- handles the rollout response for a button 
		private function onMouseOut(evt:MouseEvent):void{
			//trace("BounceButtonTweenLite :: onMouseOut");
			if(isActive) {
				unhighlightMe();
			}
		}
		   
		//- plays the highlight animation for a button
		public function highlightMe():void {
			//trace("BounceButtonTweenLite :: highlightMe");
			scaleTween = TweenLite.to(graphic_mc, DURATION, {scaleX:FINAL_SCALE, scaleY:FINAL_SCALE, ease:Elastic.easeOut});
		}
	   
		//- plays the unhighlight animation for a button
		public function unhighlightMe():void {
			//trace("BounceButtonTweenLite :: unhighlightMe");
			scaleTween = TweenLite.to(graphic_mc, DURATION, {scaleX:1, scaleY:1, ease:Elastic.easeOut});
		}
	   
		//- unlocks the button to allow highlighting or unhighlighting
		public function enableMe():void {
			//trace("BounceButtonTweenLite :: enableMe");
			isActive = true;
		}
	   
		//- locks the button to prevent highlighting or unhighlighting
		public function disableMe():void {
			//trace("BounceButtonTweenLite :: disableMe");
			isActive = false;
		}
	} //end class
} //end package